Loading...
Searching...
No Matches
AVTree
libavutil » Data Structures

Low-complexity tree container More...

## Functions

struct AVTreeNode * | av_tree_node_alloc (void)
| Allocate an AVTreeNode.
void * | av_tree_find (const struct AVTreeNode *root, void *key, int(*cmp)(const void *key, const void *b), void *next[2])
| Find an element.
void * | av_tree_insert (struct AVTreeNode **rootp, void *key, int(*cmp)(const void *key, const void *b), struct AVTreeNode **next)
| Insert or remove an element.
void | av_tree_destroy (struct AVTreeNode *t)
void | av_tree_enumerate (struct AVTreeNode *t, void *opaque, int(*cmp)(void *opaque, void *elem), int(*enu)(void *opaque, void *elem))
| Apply enu(opaque, &elem) to all the elements in the tree in a given range.

## Variables

const int | av_tree_node_size

## Detailed Description

Low-complexity tree container

Insertion, removal, finding equal, largest which is smaller than and smallest which is larger than, all have O(log n) worst-case complexity.

## Function Documentation

## av_tree_node_alloc()

struct AVTreeNode * av_tree_node_alloc | ( | void |  | ) |

Allocate an AVTreeNode.

## av_tree_find()

void * av_tree_find | ( | const struct AVTreeNode * | root,
|  | void * | key,
|  | int(* | cmp )(const void *key, const void *b),
|  | void * | next[2] )

Find an element.

Parameters

  root | a pointer to the root node of the tree
  next | If next is not NULL, then next[0] will contain the previous element and next[1] the next element. If either does not exist, then the corresponding entry in next is unchanged.
  cmp | compare function used to compare elements in the tree, API identical to that of Standard C's qsort It is guaranteed that the first and only the first argument to cmp() will be the key parameter to av_tree_find(), thus it could if the user wants, be a different type (like an opaque context).

Returns
  An element with cmp(key, elem) == 0 or NULL if no such element exists in the tree.

## av_tree_insert()

void * av_tree_insert | ( | struct AVTreeNode ** | rootp,
|  | void * | key,
|  | int(* | cmp )(const void *key, const void *b),
|  | struct AVTreeNode ** | next )

Insert or remove an element.

If *next is NULL, then the supplied element will be removed if it exists. If *next is non-NULL, then the supplied element will be inserted, unless it already exists in the tree.

Parameters

  rootp | A pointer to a pointer to the root node of the tree; note that the root node can change during insertions, this is required to keep the tree balanced.
  key | pointer to the element key to insert in the tree

  next

  Used to allocate and free AVTreeNodes. For insertion the user must set it to an allocated and zeroed object of at least av_tree_node_size bytes size. av_tree_insert() will set it to NULL if it has been consumed. For deleting elements *next is set to NULL by the user and av_tree_insert() will set it to the AVTreeNode which was used for the removed element. This allows the use of flat arrays, which have lower overhead compared to many malloced elements. You might want to define a function like:
  void *tree_insert(struct AVTreeNode **rootp, void *key,
  int (*cmp)(void *key, const void *b),
  AVTreeNode **next)
  {
  if (!*next)
  *next = av_mallocz(av_tree_node_size);
  return av_tree_insert(rootp, key, cmp, next);
  }
  void *tree_remove(struct AVTreeNode **rootp, void *key,
  int (*cmp)(void *key, const void *b, AVTreeNode **next))
  {
  av_freep(next);
  return av_tree_insert(rootp, key, cmp, next);
  }
  av_freep
  void av_freep(void *ptr)
  Free a memory block which has been allocated with a function of av_malloc() or av_realloc() family,...
  av_mallocz
  void * av_mallocz(size_t size) av_malloc_attrib
  Allocate a memory block with alignment suitable for all memory accesses (including vectors if availab...
  av_tree_insert
  void * av_tree_insert(struct AVTreeNode **rootp, void *key, int(*cmp)(const void *key, const void *b), struct AVTreeNode **next)
  Insert or remove an element.
  av_tree_node_size
  const int av_tree_node_size

  cmp | compare function used to compare elements in the tree, API identical to that of Standard C's qsort

Returns
  If no insertion happened, the found element; if an insertion or removal happened, then either key or NULL will be returned. Which one it is depends on the tree state and the implementation. You should make no assumptions that it's one or the other in the code.

## av_tree_destroy()

void av_tree_destroy | ( | struct AVTreeNode * | t | ) |

## av_tree_enumerate()

void av_tree_enumerate | ( | struct AVTreeNode * | t,
|  | void * | opaque,
|  | int(* | cmp )(void *opaque, void *elem),
|  | int(* | enu )(void *opaque, void *elem) )

Apply enu(opaque, &elem) to all the elements in the tree in a given range.

Parameters

  cmp | a comparison function that returns < 0 for an element below the range, > 0 for an element above the range and == 0 for an element inside the range

Note
  The cmp function should use the same ordering used to construct the tree.

## Variable Documentation

## av_tree_node_size

const int av_tree_node_size

extern